//==============================================================================//
//				DirectX9pėpCu Luna									//
//==============================================================================//
//																				//
//	ŐVł̒uĂURL														//
//																				//
//		TWINTAIL LOVERS.														//
//			http://www.twin-tail.jp/											//
//																				//
//	ⓙꏊ																//
//																				//
//		BBS																		//
//			TWINTAIL LOVERS.̌f											//
//																				//
// DirectX Library "Luna for DirectX 9.0c"										//
// Copyright (C) 2003-2005 t`												//
// All rights reserved.															//
//																				//
//==============================================================================//

/** @file
    @brief		蔻NX
    @author		t`
    @since		2003.07.01
*/

#ifndef ___LUNACOLLISION_H___
#define ___LUNACOLLISION_H___


//======================================================================
// INCLUDE
//======================================================================
#include "LunaBase.h"

namespace lunadxmath{
//=============================================================================
/**
	@brief	蔻NX

	{Iȓ蔻菈sNXłB
	Qc֘A̓蔻͑Sē삵܂A
	Rc֘A̓蔻͖̂̂܂B

    @todo	------------------------
    @bug	------------------------
*/
//=============================================================================

class LunaCollision
{
public:
	// Qc
	static bool Point_Point( POINT2D *pPt1, POINT2D *pPt2 );												///< _Ɛ
	static bool Point_Line( POINT2D *pPt, LINE2D *pLine );													///< _Ɛ
	static bool Point_Rect( POINT2D *pPt, RECT2D *pRect );													///< _Ǝlp
	static bool Point_Circle( POINT2D *pPt, CIRCLE2D *pCir );												///< _Ɖ~
	static bool Point_Polygon( POINT2D *pPt, POLYGON2D *pPoly );											///< _Ƒp`
	static bool Rect_Rect( RECT2D *pRect1, RECT2D *pRect2 );												///< lpƎlp
	static bool Rect_Circle( RECT2D *pRect, CIRCLE2D *pCir );												///< lpƉ~
	static bool Rect_Line( RECT2D *pRect, LINE2D *pLine );													///< lpƐ
	static bool Rect_Polygon( RECT2D *pRect, POLYGON2D *pPoly );											///< lpƑp`
	static bool Circle_Circle( CIRCLE2D *pCir1, CIRCLE2D *pCir2 );											///< ~Ɖ~
	static bool Circle_Line( CIRCLE2D *pCir, LINE2D *pLine );												///< ~Ɛ
	static bool Circle_Polygon( CIRCLE2D *pCir, POLYGON2D *pPoly );											///< ~Ƒp`
	static bool Line_Line( LINE2D *pLine1, LINE2D *pLine2 );												///< Ɛ
	static bool Line_Polygon( LINE2D *pLine, POLYGON2D *pPoly );											///< Ƒp`
	static bool Polygon_Polygon( POLYGON2D *pPoly1, POLYGON2D *pPoly2 );									///< p`Ƒp`
	// Rc
	static bool Point_Point_3D( POINT3D *pPt1, POINT3D *pPt2 );												///< _Ɠ_
	static bool Point_Sphere_3D( POINT3D *pPt, SPHERE3D *pSph );											///< _Ƌ
	static bool Point_Line_3D( POINT3D *pPt, LINE3D *pLine );												///< _Ɛ
	static bool Point_Plane_3D( POINT3D *pPt, PLANE3D *pPlane );											///< _Ɩ
	static bool Point_Box_3D( POINT3D *pPt, BOX3D *pBox );													///< _Ɣ
	static bool Sphere_Sphere_3D( SPHERE3D *pSph1, SPHERE3D *pSph2 );										///< Ƌ
	static bool Sphere_Line_3D( SPHERE3D *pSph, LINE3D *pLine );											///< Ɛ
	static bool Sphere_Plane( SPHERE3D *pSph, PLANE3D *pPlane );											///< Ɩ
	static bool Sphere_Box_3D( SPHERE3D *pSph, BOX3D *pBox );												///< Ɣ
	static bool Line_Plane_3D( LINE3D *pLine, PLANE3D *pPlane, POINT3D *pPoints, POINT3D *pPos );			///< Ɩ
	static bool Line_Box_3D( LINE3D *pLine, BOX3D *pBox );													///< Ɣ
	static bool Line_Triangle_3D( LINE3D* pLine, POINT3D Points[], Float *pT, Float *pU, Float *pV );		///< ƎOp`
	static bool Box_Box_3D( BOX3D *pBox1, BOX3D *pBox2 );													///< Ɣ
	static bool FrustumCulling( BOX3D *pFrustum, BOX3D *pBox );												///< r[tX^Ɣ
	static bool Plane_Plane_3D( PLANE3D *pPlane1, PLANE3D *pPlane2, POINT3D Points1[], POINT3D Points2[] );	///< ʓm̔

	// RWf[^쐬֐
	static void CreateBox( BOX3D *pOut, POINT3D *pMinPt, POINT3D *pMaxPt, LMATRIX *pMatrix );				///< 
	static void CreateBoxProjection( BOX3D *pOut, POINT3D *pMinPt, POINT3D *pMaxPt, LMATRIX *pMatrix );		///< 
	static void CreatePlaneFromPoint( PLANE3D *pOut, POINT3D *pPt0, POINT3D *pPt1, POINT3D *pPt2 );			///< ʐ
	static void CreatePlane( PLANE3D *pOut, POINT3D *pPt, POINT3D *pNormal );								///< ʐ

	static bool PlaneIntersectLine( POINT3D *Intersection, PLANE3D *pPlane, POINT3D *pEdge0, POINT3D *pEdge1 );	///< ʂƒ̌_
	static bool EdgeIntersectsQuad( POINT3D* pEdges, POINT3D* pFacePoints, PLANE3D* pPlane, POINT3D *pHitPos );	///< S_ō\镽ʂƐ̌
};
}//eon

#endif // ___LUNACOLLISION_H___

