//==============================================================================//
//				DirectX9pėpCu Luna									//
//==============================================================================//
//																				//
//	ŐVł̒uĂURL														//
//																				//
//		TWINTAIL LOVERS.														//
//			http://www.twin-tail.jp/											//
//																				//
//	ⓙꏊ																//
//																				//
//		BBS																		//
//			TWINTAIL LOVERS.̌f											//
//																				//
// DirectX Library "Luna for DirectX 9.0c"										//
// Copyright (C) 2003-2005 t`												//
// All rights reserved.															//
//																				//
//==============================================================================//

/** @file
    @brief		sNX
    @author		t`
    @since		2003.07.01
*/

#ifndef ___LUNAMATRIX_H___
#define ___LUNAMATRIX_H___


//=============================================================================
// INCLUDE
//=============================================================================
#include "dx_select.hpp"
#include "LunaVector3.h"
#include "LunaQuaternion.h"
namespace lunadxmath{


//=============================================================================
/**
	@brief	sNX

	seՂɈ悤ɂNXłB
	Direct3DX̕⏕֐SSE3DNowł̉Z
	⍲邽߂ɓI16BytePʂŎI
	ACg܂B
	̂߁AoɒڃANZXłȂȂǂ
	sւȓ_܂B

    @todo	------------------------
    @bug	------------------------
*/
//=============================================================================
class CMatrix
{
	Uint8 Data[sizeof(D3DXMATRIX) + 16];							///< spf[^
	D3DXMATRIX *pM;															///< s擪AhX

public:
	CMatrix();																///< RXgN^
	CMatrix( CMatrix &Mat );												///< RXgN^
	~CMatrix(){}															///< fXgN^

	void Init( void );

	/**
		@brief l擾
		s̎wvf擾B

		@param i	[in] 
		@param j	[in] s
	*/
	Float Get( Sint32 i, Sint32 j )
	{
		return pM->m[i][j];
	}

	/**
		@brief lݒ
		s̎wvfݒB

		@param i	[in] 
		@param j	[in] s
		@param Data	[in] l
	*/
	void Set( Sint32 i, Sint32 j, Float Data )
	{
		pM->m[i][j] = Data;
	}

	D3DXMATRIX *Get( void );												///< s̐擪AhX擾
	void Get( D3DXMATRIX *pOut );											///< sf[^擾
	void Set( D3DXMATRIX *pIn );											///< sf[^ݒ

	void Identity( void );													///< CӍsPʉ
	void Transpose( CMatrix *pIn );											///< CӍs]u
	void Inverse( CMatrix *pIn );											///< CӍsts
	void Normalize( CMatrix *pIn );											///< CӍs𐳋K
	void Multiply( CMatrix *pIn1, CMatrix *pIn2 );							///< CӍs

	void Transpose( void );													///< ]u
	void Inverse( void );													///< ts
	void Normalize( void );													///< K
	void Multiply( CMatrix *pIn );											///< 

	void RotationX( Sint32 Angle );											///< w]s񐶐
	void RotationY( Sint32 Angle );											///< x]s񐶐
	void RotationZ( Sint32 Angle );											///< y]s񐶐
	void RotationZXY( Sint32 AngleX, Sint32 AngleY, Sint32 AngleZ );				///< R]s񐶐
	void RotationAxis( Sint32 Angle, class CVector3 *pAxis );					///< Cӎ]s񐶐
	void Rotation( Sint32 rotx, Sint32 roty, Sint32 rotz );						///< R]s񐶐
	void Scaling( Float sx, Float sy, Float sz );							///< gks񐶐
	void Translation( Float px, Float py, Float pz );						///< ړs񐶐
	void RotateVector( class CVector3 *pIn1, class CVector3 *pIn2, class CVector3 *pAxis = NULL );	///< CӃxNgCӃxNgւ̉]s񐶐

	void Perspective( Float fov, Float near_z, Float far_z, Float aspect );	///< ϊps̐
	void Ortho( Float w, Float h, Float near_z, Float far_z );				///< ˉes񐶐

	void LookAt( class CVector3 *pEye, class CVector3 *pAt, class CVector3 *pUp );			///< p̍s

	CMatrix &operator = ( const CMatrix &In );								///< Zq
	CMatrix &operator = ( const class CQuaternion &In );					///< Zq
};

}//eon

#endif // ___LUNAMATRIX_H___
